# Copyright (c) 1993, 1994, 1995, 1996, 1997  The TERENA Association
#
# All Rights Reserved
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
# AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
# DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# $Id: older.pl,v 1.2 1997/10/02 12:18:56 chris Exp $
#
# older <source> <target> [<target>]
#
# Change modification time on targets so they are older than source
# 

# number of seconds older
$::EARLIER = 60;

{
  my ($source, @targets) = @ARGV;

  my ($mtime)=(stat($source))[9]
    or die "stat() on [$source] failed: $!";

  $mtime -= $::EARLIER;

  foreach $target (@targets) {
    utime $mtime, $mtime, $target
      or die "utime() on [$target] failed: $!";
  }
}
